#include <string.h>
#include "pgraph.h"
#define W 640            // 
#define H 360            // 
#define STEP 2           // 

/*
// 
image* create_frame(image *img1, image *img2, image *img3)
{
    static int disp = 0; //
    disp += STEP;
    // 
    for (int j = 0; j < H; j += 2)
    {
        for (int i = 0; i < disp; i++)
            set_color(img3, i, j, get_color(img2, i + W - disp, j));
        for (int i = disp; i < W; i++)
            set_color(img3, i, j, get_color(img1, i - disp, j));
    }
    // 
    for (int j = 1; j < H; j += 2)
    {
        for (int i = 0; i < W - disp; i++)
            set_color(img3, i, j, get_color(img1, i + disp, j));
        for (int i = W - disp; i < W; i++)
            set_color(img3, i, j, get_color(img2, i - W + disp, j));
    }
    return img3;
}
*/

/*
// 
image* create_frame(image *img1, image *img2, image *img3)
{
    static int disp = 0; //
    disp += STEP;
    color *pixels1 = img1->pixels;
    color *pixels2 = img2->pixels;
    color *pixels3 = img3->pixels;
    // 
    for (int j = 0; j < H; j += 2)
    {
        memcpy(pixels3 + j * W, pixels2 + (j + 1) * W - disp, disp * sizeof(color));
        memcpy(pixels3 + j * W + disp, pixels1 + j * W, (W - disp) * sizeof(color));
    }
    // 
    for (int j = 1; j < H; j += 2)
    {
        memcpy(pixels3 + j * W, pixels1 + j * W + disp, (W - disp) * sizeof(color));
        memcpy(pixels3 + (j + 1) * W - disp, pixels2 + j * W, disp * sizeof(color));
    }
    return img3;
}
*/

// 
image* create_frame(image *img1, image *img2, image *img3)
{
    static int disp = 0; //
    disp += STEP;
    int disp2 = W - disp;
    int disp_size = disp * sizeof(color);
    int disp2_size = disp2 * sizeof(color);
    int h = H;
    int oddness = 1;     //1,     
    color *pixels1 = img1->pixels;
    color *pixels2 = img2->pixels;
    color *pixels3 = img3->pixels;
    while (h--)
    {
        if (oddness)
        {
            memcpy(pixels3, pixels2 + disp2, disp_size);
            memcpy(pixels3 + disp, pixels1, disp2_size);
        }
        else
        {
            memcpy(pixels3, pixels1 + disp, disp2_size);
            memcpy(pixels3 + disp2, pixels2, disp_size);
        }
        pixels1 += W;
        pixels2 += W;
        pixels3 += W;
        oddness = 1 - oddness;
    }
    return img3;
}

int main()
{
    image *img1 = create_image(W, H);
    //image *img1 = load_from_file("image1.bmp");
    image *img2 = load_from_file("image2.bmp");
    image *img3 = create_image(W, H);
    char filename[13];
    int i;
    for(i = 1; i <= 25; i++)
    {   
       sprintf(filename, "results\\%03d.bmp", i);
       save_to_file(img1, filename);
    }
    int j = i + W / STEP;
    for(; i < j; i++)
    {   
       sprintf(filename, "results\\%03d.bmp", i);
       save_to_file(create_frame(img1, img2, img3), filename);
    }
    j = i + 23;
    for(; i <= j; i++)
    {
       sprintf(filename, "results\\%03d.bmp", i);
       save_to_file(img2, filename);
    }
    free(img1);
    free(img2);
    free(img3);
    return 0;
}
